import _asyncToGenerator from '@babel/runtime/helpers/asyncToGenerator';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import _regeneratorRuntime from '@babel/runtime/regenerator';

var QueueLoader = /*#__PURE__*/function () {
  function QueueLoader(props) {
    _classCallCheck(this, QueueLoader);

    _defineProperty(this, "queue", void 0);

    _defineProperty(this, "loadDataFunc", void 0);

    _defineProperty(this, "loading", false);

    var loadDataFunc = props.loadDataFunc,
        checkInQueueFunc = props.checkInQueueFunc;
    this.queue = [];
    this.loadDataFunc = loadDataFunc;

    if (checkInQueueFunc) {
      this.checkInQueueFunc = checkInQueueFunc;
    }
  }

  _createClass(QueueLoader, [{
    key: "checkInQueueFunc",
    value: function checkInQueueFunc(queue, checkData) {
      return queue.map(function (_ref) {
        var postData = _ref.postData;
        return JSON.stringify(postData);
      }).includes(JSON.stringify(checkData));
    }
  }, {
    key: "getData",
    value: function () {
      var _getData = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(props) {
        var postData, _props$passLoading, passLoading, loadDataFunc, checkInQueueFunc, returnData;

        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                postData = props.postData, _props$passLoading = props.passLoading, passLoading = _props$passLoading === void 0 ? false : _props$passLoading;
                loadDataFunc = this.loadDataFunc, checkInQueueFunc = this.checkInQueueFunc;

                if (loadDataFunc) {
                  _context.next = 4;
                  break;
                }

                throw new Error('loadDataFunc 未定义');

              case 4:
                if (checkInQueueFunc) {
                  _context.next = 6;
                  break;
                }

                throw new Error('checkInQueueFunc 未定义');

              case 6:
                if (!passLoading) {
                  _context.next = 12;
                  break;
                }

                _context.next = 9;
                return loadDataFunc(props);

              case 9:
                returnData = _context.sent;
                _context.next = 16;
                break;

              case 12:
                if (!checkInQueueFunc(this.queue, postData)) {
                  this.queue.push(props);
                }

                if (this.loading) {
                  _context.next = 16;
                  break;
                }

                _context.next = 16;
                return this.nextLoadData();

              case 16:
                return _context.abrupt("return", returnData);

              case 17:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getData(_x) {
        return _getData.apply(this, arguments);
      }

      return getData;
    }()
  }, {
    key: "nextLoadData",
    value: function () {
      var _nextLoadData = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
        var props, _loadDataFunc;

        return _regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                this.loading = true;
                props = this.queue.shift();

                if (!props) {
                  _context2.next = 8;
                  break;
                }

                _loadDataFunc = this.loadDataFunc;
                _context2.next = 6;
                return _loadDataFunc(props);

              case 6:
                _context2.next = 8;
                return this.nextLoadData();

              case 8:
                this.loading = false;

              case 9:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function nextLoadData() {
        return _nextLoadData.apply(this, arguments);
      }

      return nextLoadData;
    }()
  }]);

  return QueueLoader;
}();

var queueLoaderFactory = {
  getQueueLoader: function getQueueLoader(props) {
    var key = props.key;

    if (!this[key]) {
      this[key] = new QueueLoader(props);
    }

    return this[key];
  }
};

export { queueLoaderFactory };

    if(typeof window !== 'undefined') {
      window.pgk__2bitlab_queue_load_version = '1.0.3'
    }
    /*!
  * @2bitlab/queue-load v1.0.3
  * (c) 2021 thomas-ballo <liurongliang@balloai.com>
  * @license MIT
  */
