(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@babel/runtime/helpers/asyncToGenerator'), require('@babel/runtime/helpers/classCallCheck'), require('@babel/runtime/helpers/createClass'), require('@babel/runtime/helpers/defineProperty'), require('@babel/runtime/regenerator')) :
  typeof define === 'function' && define.amd ? define(['exports', '@babel/runtime/helpers/asyncToGenerator', '@babel/runtime/helpers/classCallCheck', '@babel/runtime/helpers/createClass', '@babel/runtime/helpers/defineProperty', '@babel/runtime/regenerator'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["@2bitlab/queue-load"] = {}, global._asyncToGenerator, global._classCallCheck, global._createClass, global._defineProperty, global._regeneratorRuntime));
})(this, (function (exports, _asyncToGenerator, _classCallCheck, _createClass, _defineProperty, _regeneratorRuntime) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  var _asyncToGenerator__default = /*#__PURE__*/_interopDefaultLegacy(_asyncToGenerator);
  var _classCallCheck__default = /*#__PURE__*/_interopDefaultLegacy(_classCallCheck);
  var _createClass__default = /*#__PURE__*/_interopDefaultLegacy(_createClass);
  var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);
  var _regeneratorRuntime__default = /*#__PURE__*/_interopDefaultLegacy(_regeneratorRuntime);

  var QueueLoader = /*#__PURE__*/function () {
    function QueueLoader(props) {
      _classCallCheck__default["default"](this, QueueLoader);

      _defineProperty__default["default"](this, "queue", void 0);

      _defineProperty__default["default"](this, "loadDataFunc", void 0);

      _defineProperty__default["default"](this, "loading", false);

      var loadDataFunc = props.loadDataFunc,
          checkInQueueFunc = props.checkInQueueFunc;
      this.queue = [];
      this.loadDataFunc = loadDataFunc;

      if (checkInQueueFunc) {
        this.checkInQueueFunc = checkInQueueFunc;
      }
    }

    _createClass__default["default"](QueueLoader, [{
      key: "checkInQueueFunc",
      value: function checkInQueueFunc(queue, checkData) {
        return queue.map(function (_ref) {
          var postData = _ref.postData;
          return JSON.stringify(postData);
        }).includes(JSON.stringify(checkData));
      }
    }, {
      key: "getData",
      value: function () {
        var _getData = _asyncToGenerator__default["default"]( /*#__PURE__*/_regeneratorRuntime__default["default"].mark(function _callee(props) {
          var postData, _props$passLoading, passLoading, loadDataFunc, checkInQueueFunc, returnData;

          return _regeneratorRuntime__default["default"].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  postData = props.postData, _props$passLoading = props.passLoading, passLoading = _props$passLoading === void 0 ? false : _props$passLoading;
                  loadDataFunc = this.loadDataFunc, checkInQueueFunc = this.checkInQueueFunc;

                  if (loadDataFunc) {
                    _context.next = 4;
                    break;
                  }

                  throw new Error('loadDataFunc 未定义');

                case 4:
                  if (checkInQueueFunc) {
                    _context.next = 6;
                    break;
                  }

                  throw new Error('checkInQueueFunc 未定义');

                case 6:
                  if (!passLoading) {
                    _context.next = 12;
                    break;
                  }

                  _context.next = 9;
                  return loadDataFunc(props);

                case 9:
                  returnData = _context.sent;
                  _context.next = 16;
                  break;

                case 12:
                  if (!checkInQueueFunc(this.queue, postData)) {
                    this.queue.push(props);
                  }

                  if (this.loading) {
                    _context.next = 16;
                    break;
                  }

                  _context.next = 16;
                  return this.nextLoadData();

                case 16:
                  return _context.abrupt("return", returnData);

                case 17:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        function getData(_x) {
          return _getData.apply(this, arguments);
        }

        return getData;
      }()
    }, {
      key: "nextLoadData",
      value: function () {
        var _nextLoadData = _asyncToGenerator__default["default"]( /*#__PURE__*/_regeneratorRuntime__default["default"].mark(function _callee2() {
          var props, _loadDataFunc;

          return _regeneratorRuntime__default["default"].wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  this.loading = true;
                  props = this.queue.shift();

                  if (!props) {
                    _context2.next = 8;
                    break;
                  }

                  _loadDataFunc = this.loadDataFunc;
                  _context2.next = 6;
                  return _loadDataFunc(props);

                case 6:
                  _context2.next = 8;
                  return this.nextLoadData();

                case 8:
                  this.loading = false;

                case 9:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, this);
        }));

        function nextLoadData() {
          return _nextLoadData.apply(this, arguments);
        }

        return nextLoadData;
      }()
    }]);

    return QueueLoader;
  }();

  var queueLoaderFactory = {
    getQueueLoader: function getQueueLoader(props) {
      var key = props.key;

      if (!this[key]) {
        this[key] = new QueueLoader(props);
      }

      return this[key];
    }
  };

  exports.queueLoaderFactory = queueLoaderFactory;

  Object.defineProperty(exports, '__esModule', { value: true });

}));

    if(typeof window !== 'undefined') {
      window.pgk__2bitlab_queue_load_version = '1.0.3'
    }
    /*!
  * @2bitlab/queue-load v1.0.3
  * (c) 2021 thomas-ballo <liurongliang@balloai.com>
  * @license MIT
  */
